;-------------------------------------;
; Keyboard hardware interrupt handler ;
;-------------------------------------;

KEYBOARD_HANDLER PROC NEAR
        @PUSH   <DS, EAX>
        MOV     AX, DS_SEL
        MOV     DS, AX

        IN      AL, PORT_KBD_A
        MOV     AH, AL
        AND     AL, 07FH

        MOV     DS:[KEY_SCAN_CODE], AL

        CMP     AH, 1DH                         ; CTRL?
        JNE     KEYBOARD_1
        MOV     DS:[KBD_SEQ], 1
        JMP     KEYBOARD_NEXT
KEYBOARD_1:
        CMP     DS:[KBD_SEQ], 1
        JNE     KEYBOARD_NEXT
        CMP     AH, 1                           ; ESC?
        JE      KEYBOARD_ERROR                  ; CTRL+ESC -> EXCEPTION #0
        MOV     DS:[KBD_SEQ], 0
        JMP     KEYBOARD_NEXT
KEYBOARD_ERROR:
        MOV     EAX, 0
;        DIV     EAX                             ; EMERGENCY "EXIT" ;)

KEYBOARD_NEXT:

        @POP    <EAX, DS>
        RET
KEYBOARD_HANDLER ENDP
